Attribute VB_Name = "MM_Main"
'TODO: DO THESE FIRST
'------------------------
'ENEM VS ENEM. COLLISIONS -- FOR TURTLES VS GOOMBA, COMPARING I TO I2 WASN'T THE SAME AS I2 TO I... HAD TO CHECK BOTH TO GET WORKING...
'TURTLES, SHELL DOES DAMAGE IF IT'S MOVING
'TURTLES (GREEN) -- check speed, add behaviors, fix bitmaps
'TURTLES - make turtle smash goombas
'ENEMIES - make mario bounce up after jumping on enemy
'MUSHROOMS
'make running anis actual speed of NES. also, adjust speed of ani with running speed (may just be one speed for walk, one for run, or may be based on exact speed)
'BUSTING BRICKS/DEATH ANIMATIONS require sprite rotation, NOT POSSIBLE with DirectDraw 7
'BLOCKS MOVE WHEN HIT (BRICKS WHEN SMALL, ?'S WHEN BIG OR SMALL)
'null block should be under the screen, out of the way.
'should bounce after jumping on enemy
'fix pits -- maybe process pit objs at setuplevel, create array of ranges. if within range, set will fall. if below ground and falling and crossing over range boundary, then hitting side of floor
'ONLY ONSCREEN ENEMIES
'collision detection on jumping into blocks should not be exact. as long as you are less than half under the block you can jumpa round it, not into the bottom of it.

'CHANGES TO BE MADE IN THE LONG-TERM
'---------------------------------------
'physics model. there currently is a momentum system, but it isn't seperate from the number of pixels moved each frame, so it doesn't actually do much. with a true momentum, if we run right, then press left, we'll slide some to the right before we can move left. we have to overcome the momentum. same goes for moving while falling/jumping
'right now jumping is simulated. we move a set number of pixels each direction for a set number of frames. the arch (crest) of the jump is done in the same way. in reailty, the arch of the jump would be created by the player's decreasing momentum, caused by gravity. the height and distance of the jump will change depending on the player's speed. also, with a physics model, we can make the player bounce after squashing an enemy, by simply giving him an upward momentum and maintaining his current forward momentum
'
'change to time-based animation? (variable fps) (pps not ppf)
'will also have to change collision detection?
'if animation is really fast, you'd collide with a block as soon as you touch it. if it's really slow you may go all the way through it
''objects that are very wide (can be blockH, PipeL, pits, etc), would they not be counted in onscreenobj if the start of the obj is off the left of the screen? may need fixed...
'
'determine keypresses in this module (DirectInput)
'still can't get rid of form, cause we need a hwnd
'
'option for windowed mode?
'restoring graphics after alt+tab not working correctly
'
'for enemy animation: could do is before drawing them, call a function (like "AdvanceAnimations") that increments a variable for each enemy type, such as "GoombaAniStep" after a set number is reached, another variable, such as "GoombaAniFrame" is incremented, which actually points to which frame to draw (note that we can consolidate anis that are of the same speed, ie goomabs and turtles may both change images after 10 frames)
'
'? BLOCK ACTIVATE ANIMATION
'
'activate enemies when closer to screen (should be able to see them fall)
'enemies sometimes get tangled up in each other
'
'differrentiate single goomba from the multi-goomba object. they are spaced differently, and because the multi-goomba object is actually further to the right than the goombas that make up the object, they are activated seemingly closer to the screen.
'example, the object itself is on column 10, then goombas may be on 8,9,and 10. so for them to be activated (come within 3 tiles of onscreen) they are activated just before they appear onscreen. which is why you can see them fall, but not the single goombas.
'how exactly to implement multi-enemy objects, i dunno yet. maybe reserve the number of enemies in the group, have one object of type "Gommbas3", then when activated, change the object type to regular goomba and create the other two in the correct place and activate those too.
'
'collision detection: when directly under 2 blocks, the one that you are more under should be hit, not the leftmost one every time


'in editor, pit must go through top two floor tiles. or maybe not (as in mario bash 1-1).
'special objs are all 3 tiles below floor or lower. we can have as many tiles below that as needed.


'--------------------
'8/14
'fixed crash when winamp or another app is using the sound
'turtles can now be jumped on and kicked

'8/12
'started work on adding green turtles

'7/3
'created "sliding" animations, but they cannot be used until we have a true physics model :(
'cleaned up some of the "todo" at the top of this page here

'7/2
'fixed moving while ducking
'blocks disapper as a temp method of busting

'6/9
'added some sounds/music (MUSIC LOOP DOESN'T SOUND SEEMLESS)

'6/6
'added ducking.

'6/4
'fixed player walk speed

'6/3
'added pits, ALTHOUGH the way they are implemented could surely improve later

'5/31
'fixed pipe collision detection

'5/29
'added PipeV objects
'added null object so that LeftMostOnscreenObj is never -1. null is the first obj of the level

'4/28
'added "small" mario state

'4/27
'added ? blocks that give a coin and deactivates

'4/25:
'taking damage
'no collision with dead enemies
'enemies die when going too far offscreen
'enemies are inactive until near onscreen (CHECK THIS)




Option Explicit
'Public Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
Public Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long
'Public Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Public MouseX As Long
Public MouseY As Long
Public Cur As Long

'key states
Public Key As Integer
Public RKey As Boolean
Public DKey As Boolean
Public LKey As Boolean
Public UKey As Boolean
Public JmpKey As Boolean
Public RunKey As Boolean

'timing and framerate
Public Frames As Integer
Public FPS As Integer
Public TimeFor60Frames As Double
Public StageTime As Long
Public StageTimeFrame As Long
Public LevelBGColor As Long
Public NumCoins As Long
Public NumLives As Long
Public MasterAniFrame2Step As Long
Public MasterAniFrame3Step As Long
Private Declare Function QueryPerformanceCounter Lib "kernel32" (lpPerformanceCount As Currency) As Long
Private Declare Function QueryPerformanceFrequency Lib "kernel32" (lpPerformanceCount As Currency) As Long
Public perfStart As Currency
Public perfStart60 As Currency
Public perfEnd As Currency
Public perfEnd60 As Currency
Public perfFreq As Currency
Public Elapsed As Double

'screen and tile sizes
Public Const ScreenOffsetX As Long = 128 'thickness of border around all sides of screen
Public Const ScreenOffsetY As Long = 24
Public ScreenResX As Long
Public ScreenResY As Long
Public ScreenGameWidth As Long
Public ScreenGameHeight As Long '256x240 is nes res. so game area will be 768x720. so offsetX is 128. offsetY is 24.
Public TileSize As Long
Public MarioWidth As Long 'same as tilesize, but makes code easier to understand
Public FloorBitmapWidth As Long

Public Const GravitySpeed As Long = 12 'PPF of gravity speed
Public MaxWalkingMomentum As Long
Public MaxRunningMomentum As Long

Public GravityFrame As Long


Public Type LevelObject
    type As Long
    X As Long
    Y As Long
    Column As Long
    width As Long
    height As Long
    state As Byte     'eg. "?" block is used, etc.
    xm As Long 'momentum
    ym As Long
End Type

Public ObjectRect As RECT
Public LObject() As LevelObject

Public OnscreenStart As Long 'this is how far, in pixels into the level we have scrolled
Public FarLeftObj As Long
Public LeftMostOnscreenObj As Long
Public RightMostOnscreenObj As Long
Public FarRightObj As Long


Public Type Enemy
    type As Long
    X As Long
    Y As Long
    Column As Long
    width As Long
    height As Long
    state As enemystates
    special As Integer 'we'll use this for any extra info we need to store. for example, with turtles, the state can be "inshell" but we need a timer for how long until he pops back out
    special2 As Integer
    xm As Long
    ym As Long 'momentum, positive number is falling
    willfall As Boolean
End Type

Public EnemyRect As RECT
Public Enemies(3) As Enemy


Public LastPlayerState As Byte
Public LastPlayerStateTemp As Byte
Public PerformJump As Boolean
Public JumpSteps As Long
Public JumpStepsUsed As Long
Public JumpFrames As Long
Public PlayerLastY As Long
Public PlayerLastYTemp As Long
Public FallingType As Long

Public Type Player1
    X As Long
    Y As Long
    height As Long
    state As Byte
    xm As Long
    ym As Long 'momentum, positive number is falling
    AniFrame As Long
    FacingLeft As Long
    willfall As Boolean
    takingdamage As Long 'above 0 is true (num frames remaining)
    BodyType As BodyTypes
    Ducking As Boolean
End Type

Public Enum BodyTypes
    Small = 0
    Big = 1
    Fire = 2
End Enum



Public PlayerRect As RECT
Public Player As Player1


Private Declare Function IntersectRect Lib "user32" (lpDestRect As RECT, lpSrc1Rect As RECT, lpSrc2Rect As RECT) As Long
Dim CollisionResult As Long


'temp
Public DebugPrinted As Boolean
Public PauseMode As Boolean
Public AdvanceFrame As Boolean
Public LockFramerate As Boolean
Public GraphicsPath As String
Public QuitGame As Boolean
Public FullScreen As Boolean




Sub Main()
    'On Error GoTo ErrHandler
    QueryPerformanceFrequency perfFreq
    
    TileSize = 48
    MarioWidth = TileSize
    FloorBitmapWidth = 48
    GraphicsPath = App.Path & "\graphics\"
    
    FullScreen = True
    Form1.InitDirectX
    ScreenResX = 1024
    ScreenResY = 768
    'todo, maybe allow screen res to be changed, not set in stone. tho gfx pack and level pack would both have to support the higher res
    ScreenGameWidth = ScreenResX - ScreenOffsetX - ScreenOffsetX
    ScreenGameHeight = ScreenResY - ScreenOffsetY - ScreenOffsetY
    SetDisplayMode ScreenResX, ScreenResY, 16
    
    CreatePrimaryAndBackBuffer
    LoadAllPics
    
    DSound.Initialize Form1.hwnd
    
    'do intro screen
    DoIntro
    
    'set up level 1
    SetUpLevel 1.1
    
    'enter main game loop
    Do Until QuitGame
        MainGameLoop
    Loop
    
    'if you get to here, game is over
    GameOver 0
'    Exit Sub
    
'ErrHandler:
'    Debug.Print "Main:  " & Err.Number & " - " & Err.Description
End Sub

Sub DoIntro()
    CreateSurfaceFromFile Background, BackgroundDesc, GraphicsPath & "Intro.bmp", ScreenResX, ScreenResY
    SetRect SrcRect, 0, 0, ScreenResX, ScreenResY
    BackBuffer.BltFast 0, 0, Background, SrcRect, DDBLTFAST_WAIT
    View.Flip Nothing, DDFLIP_WAIT
    
    Do
        DoEvents
        If Key Then Exit Sub
    Loop
    
    'ClearSurface Background, ScreenResX, ScreenResY
    Set Background = Nothing
End Sub


Sub SetUpLevel(whichLevel As Integer)
    Dim LevelFile As String
    Dim DataSet As String 'will hold, for example, object data, enemy data, etc
    Dim DataStart As Long
    Dim DataEnd As Long
    Dim NumObjects As Long
    Dim TmpArray() As String
    
    LevelFile = ReadTxtFile(App.Path & "\levels\OG.txt")
    
    DataStart = InStr(1, LevelFile, "NumObjects=") + 11
    NumObjects = CLng(Mid(LevelFile, DataStart, 4))
    ReDim LObject(NumObjects) As LevelObject
    ReDim TmpArray(NumObjects) As String
    
    StageTime = 400
    LevelBGColor = 34079
    
    'load objects section
    DataStart = InStr(1, LevelFile, "[ObjectData]") + 12
    DataEnd = InStr(1, LevelFile, "[/ObjectData]") + 13
    DataSet = Mid$(LevelFile, DataStart, (DataEnd - DataStart - 13))
    'split to array
    TmpArray = Split(DataSet, "|")
    
    
    'set object properties
    Dim i As Long
    For i = 0 To (NumObjects - 1)
        With LObject(i)
          .type = Left(TmpArray(i), 3)
          .Column = CLng(Mid(TmpArray(i), 4, 3))
          .X = (.Column * TileSize) ' + ScreenOffsetX
          .Y = (CLng(Mid(TmpArray(i), 7, 2)) * TileSize) + 72 ' + ScreenOffsetY + 72 'add 72 cause top of screen is reserved for texts
          .width = GetObjectDimension(0, .type)
          .height = GetObjectDimension(1, .type)
        End With
    Next
    
    
    
    'place temp enemies
    For i = 0 To UBound(Enemies)
        With Enemies(i)
          .type = enemy_goomba
          .width = TileSize
          .height = TileSize
          .Column = (i + 14)
          .X = (.Column * TileSize) ' + ScreenOffsetX
          .Y = (1 * TileSize) + 72 ' + ScreenOffsetY + 72
          .xm = -2
          .ym = 0
          .state = state_inactive
        End With
    Next
    
    Enemies(0).Column = 10
    Enemies(0).X = (Enemies(0).Column * TileSize) ' + ScreenOffsetX
    Enemies(0).Y = (0 * TileSize) + 72 ' + ScreenOffsetY + 72
    Enemies(1).Column = 14
    Enemies(1).X = (Enemies(1).Column * TileSize) ' + ScreenOffsetX
    Enemies(1).Y = (2 * TileSize) + 72 ' + ScreenOffsetY + 72
    Enemies(2).Column = 19
    Enemies(2).X = (Enemies(2).Column * TileSize) ' + ScreenOffsetX
    Enemies(2).Y = (5 * TileSize) + 72 ' + ScreenOffsetY + 72
    
    Enemies(3).Column = 45
    Enemies(3).X = (Enemies(3).Column * TileSize) ' + ScreenOffsetX
    Enemies(3).Y = (0 * TileSize) + 72 ' + ScreenOffsetY + 72
    
    
    Enemies(0).type = enemy_turtle_green
    Enemies(0).height = TileSize + (TileSize * 0.5)
    
    
    'set player position
    Player.X = 0
    Player.Y = 0
    Player.xm = 0
    Player.ym = 0
    Player.FacingLeft = 0
    

    'rest variables
    OnscreenStart = 0
    LeftMostOnscreenObj = -1
    RightMostOnscreenObj = -1
    Player.state = Standing
    FallingType = Standing
    
    'find left-most onscreen object
    For i = 0 To UBound(LObject)
        If (LObject(i).X + LObject(i).width > OnscreenStart) And (LObject(i).X < OnscreenStart + ScreenGameWidth) Then
            LeftMostOnscreenObj = i
            Exit For
        End If
    Next
    
    'find right-most onscreen object
    If LeftMostOnscreenObj > -1 Then
        For i = LeftMostOnscreenObj To UBound(LObject)
            If LObject(i).X < OnscreenStart + ScreenGameWidth Then
                RightMostOnscreenObj = i
            Else
                'no longer dealing with onscreen objects, so quit
                Exit For
            End If
        Next
    End If
    
    'todo (tmp):
    NumCoins = 0
    Player.BodyType = Big
    Player.height = PlayerBig
    
    
    DSound.PlaySound SoundID(MusicOverworld)
    
End Sub



Sub MainGameLoop()

    On Error GoTo ErrHandler
    ShowCursor 1
    Cur = 1
    Dim i As Long


  Do
  
    QueryPerformanceCounter perfStart
'    If Frames = 1 Then
'        perfStart60 = perfStart
'    ElseIf Frames = 60 Then
'        QueryPerformanceCounter perfEnd60
'        'Calculate elapsed time (in milliseconds, eg 1000 = 1 second)
'        Elapsed = 1000 * (perfEnd60 - perfStart60) / perfFreq
'        TimeFor60Frames = 1000 / Elapsed
'        Frames = 0
'    End If
    Frames = Frames + 1
    StageTimeFrame = StageTimeFrame + 1
    If StageTimeFrame = 25 Then
        StageTime = StageTime - 1
        StageTimeFrame = 1
    End If
    

    If PauseMode Then
        Do Until PauseMode = False
            DoEvents
            If AdvanceFrame Then
                AdvanceFrame = False
                Exit Do
            End If
        Loop
    End If

  
    DoEvents
        

    
    'clear the backbuffer
    SetRect DestRect, ScreenOffsetX, ScreenOffsetY, ScreenGameWidth, ScreenGameHeight
    BackBuffer.BltColorFill DestRect, LevelBGColor
    
    
    LastPlayerState = LastPlayerStateTemp
    LastPlayerStateTemp = Player.state
    If LastPlayerState <> Player.state Then
        'if state has changed, go to first frame of new animation
        Player.AniFrame = 1
    End If


    'walk/run speed is not constant, but alternates each frame
    If Frames Mod 2 = 0 Then
        'if even number
        MaxWalkingMomentum = 3
        MaxRunningMomentum = 6
    Else
        MaxWalkingMomentum = 6
        MaxRunningMomentum = 9
    End If
    
    
    'auto-decrease player's xm so that player stops moving if no buttons are being pressed
    Select Case Player.state
    Case Jumping, Falling
        'do not apply if player is jumping or falling
    Case Else
        If Player.xm > 0 Then
            'if moving to the right
            Player.xm = Player.xm - 1
        ElseIf Player.xm < 0 Then
            'if moving to the left
            Player.xm = Player.xm + 1
        End If
    End Select
    
    
    'if taking damage, count down time until no longer invincible
    'todo, we could use this same property for when invincible due to a star. we could have it a negative number and increase it each time tho. if takingdamage is anything but 0 then draw flashing. if negative then collision with enemies but no damage. might rename property tho.
    If Player.takingdamage > 0 Then
        Player.takingdamage = Player.takingdamage - 1
    End If


    'move mario -- apply user input, change momentums, initiate jumps, etc.
    'todo: this is a temp solution. if we had a physics model, we could simply set momentums and then gravity is applied each frame. then when we jump on an enemy for example, we simply set mario's upward momentum, causing him to bounce up over the next few frames. also, the jump height and distance would vary depending on running speed, and the ability to direct your jump/fall left and right would feal natural. you shouldn't be able to turn on a dime in midair, rather you have to overcome your forward momentum
    If PerformJump Then
        'todo - calculate initial ym to give to player. xm plays a factor.
        Dim JumpSpeed As Integer
        Dim JumpHeight As Integer
        Dim JumpedSoFar As Integer
        Dim DoneCalculating As Boolean
        
        If JumpFrames = 0 Then
            'start of jump
            JumpHeight = TileSize
            'Player.willfall = False
            JumpSpeed = -GravitySpeed - 12
            DoneCalculating = False
            JumpedSoFar = 0
            Player.state = Jumping
            DSound.PlaySound SoundID(SndJump)
        End If
        
        'jump higher if button held for 3 frames
        JumpFrames = JumpFrames + 1
        If JumpFrames >= 3 Then
            If JmpKey Then
                JumpFrames = 1
                If DoneCalculating = False Then JumpHeight = JumpHeight + 24
            Else
                DoneCalculating = True
            End If
        End If
        
        'dont jump higher than max
        If JumpHeight >= 204 Then '(192) added 12 to this to try to fix not being able to land on block for tiles tall
            DoneCalculating = True
            JumpHeight = 204
        End If
        
        Player.ym = JumpSpeed
        JumpedSoFar = JumpedSoFar - Player.ym - GravitySpeed
        
        Select Case JumpHeight - JumpedSoFar
            Case Is <= 0
                JumpSpeed = 0
                PerformJump = False
                Player.ym = 0
            Case 1 To 3
                Player.ym = -GravitySpeed ' - 3
            Case 4 To 6
                Player.ym = -GravitySpeed - 3
            Case 7 To 9
                Player.ym = -GravitySpeed - 6
        End Select
    End If

    
    If Player.Ducking = False Or (Player.Ducking = True And Player.ym <> 0) Then
        'if we're ducking we can't move around, unless we're falling or jumping
        If RunKey Then
            If RKey Then
                Player.xm = Player.xm + 3
                If Player.xm > MaxRunningMomentum Then Player.xm = MaxRunningMomentum
            End If
            If LKey Then
                Player.xm = Player.xm - 3
                If Player.xm < -MaxRunningMomentum Then Player.xm = -MaxRunningMomentum
            End If
        Else
            If RKey Then
                Player.xm = Player.xm + 2
                If Player.xm > MaxWalkingMomentum Then Player.xm = MaxWalkingMomentum
            End If
            If LKey Then
                Player.xm = Player.xm - 2
                If Player.xm < -MaxWalkingMomentum Then Player.xm = -MaxWalkingMomentum
            End If
        End If
    End If
    
    'temp
    If UKey Then
        Player.ym = -GravitySpeed - 3
    End If
    
    If DKey Then
        If (Player.Ducking = False) And (Player.BodyType = Big) Then
            'duck
            Player.height = PlayerSml 'for collision detection
            Player.Y = Player.Y + TileSize
            Player.state = Ducking
            Player.Ducking = True
        End If
    Else
        If (Player.Ducking = True) Then
            'un-duck
            Player.height = PlayerBig
            Player.Y = Player.Y - TileSize
            Player.state = Standing
            Player.Ducking = False
        End If
    End If
    

    

    'move/activate/update enemies
    For i = 0 To UBound(Enemies)
        If Enemies(i).state < state_inactive Then
        
            'update enemy state (eg .special or .special 2 for counting down time for death animation etc)
            'todo, if we later need to store things other than countdowns, we can add variables like .specialCD (CD=countdown). letting us know if we need to decrease it or not
            If Enemies(i).special <> 0 Then
                Enemies(i).special = Enemies(i).special - 1
            End If
            If Enemies(i).special2 <> 0 Then
                Enemies(i).special2 = Enemies(i).special2 - 1
            End If
            
            'TODO: somewhere around here we can check enemy's state
            '  for dying and perform the movements needed for the death ani.
            '  using the .special or .special2 as a frame count.
            '  death animations (AND ALSO BRICK BUSTING DONE SIMILARLY),
            '  require sprite rotation, something not possible with
            '  the DirectDraw 7 being used right now.
            
        
            'move enemy
            Enemies(i).X = Enemies(i).X + Enemies(i).xm
            'note: the y is altered by the code that checks if they are standing on solid ground. later tho, when we have jumping turtles and the such, we'll need to alter the y here or elsewhere as well
            'Select Case Enemies(i).type
            '    Case enemy_goomba
            '        If Enemies(i).state = state_normal Then Enemies(i).X = Enemies(i).X + Enemies(i).xm
            '    Case enemy_turtle_green
            '        Enemies(i).X = Enemies(i).X + Enemies(i).xm
            'End Select
        End If
        
        'activate enemies as they come onscreen and kill those that go too far offscreen
        If Enemies(i).X < OnscreenStart - (TileSize * 4) Then
            'todo, check this
            'off left side of screen too far, so kill him
            Enemies(i).state = state_dead
            Enemies(i).X = -9999
        ElseIf Enemies(i).X > OnscreenStart + ScreenGameWidth + (TileSize * 4) Then
            'off right side of screen too far, so kill him
            If Enemies(i).state <> state_inactive Then
                Enemies(i).state = state_dead
                Enemies(i).X = -9999
            End If
        Else
            If Enemies(i).state = state_inactive Then
                If Enemies(i).X < OnscreenStart + ScreenGameWidth + (TileSize * 3) Then
                    'enemy is onscreen (or within active bounds)
                    'activate if inactive
                    Enemies(i).state = state_normal
                End If
            End If
        End If
    Next
    
    
    
    
    'apply gravity to player, changing momentum
    'temp method of making jump arch
    If Player.willfall Then
        'store previous animation type to be used for fall
        If Player.state <> Falling Then FallingType = Player.state
    
        If Not (PerformJump) Then
            GravityFrame = GravityFrame + 1
            'gradually apply at first, gravity gets stronger every 3 frames
            Select Case GravityFrame
            Case 1 To 3
                Player.ym = Player.ym + (GravitySpeed + (-GravitySpeed + 1))
                Player.state = Falling
            Case 4 To 6
                Player.ym = Player.ym + (GravitySpeed + (-GravitySpeed + 2))
                Player.state = Falling
            Case 7 To 9
                Player.ym = Player.ym + (GravitySpeed + (-GravitySpeed + 3))
                Player.state = Falling
            Case Else
                Player.ym = Player.ym + GravitySpeed
                Player.state = Falling
            End Select
        Else
            Player.ym = Player.ym + GravitySpeed
        End If
    End If
    
    If Player.ym > GravitySpeed Then Player.ym = GravitySpeed
    
    
    
    
    'see if player is standing on object such as ground or block
    If Player.willfall Then Player.Y = Player.Y + GravitySpeed
    Player.willfall = True
    
    If Not (PerformJump) Then
        If Player.Y + Player.height > ScreenGameHeight - 72 + TileSize Then
            'has fallen into a pit
            PlayerTakeDamage True
        ElseIf Player.Y + Player.height > ScreenGameHeight - 72 Then
            'below ground level, so unless in a pit, water, or lava, then we're standing
            If CheckForPit = False Then '(CheckForPit is a function)
                Player.willfall = False
                GravityFrame = 0
                If Player.ym > 0 Then Player.ym = 0
                Player.Y = ScreenGameHeight - 72 - Player.height + 3
                If Player.Ducking = False Then
                    'change state from falling or jumping to walking, running, etc.
                    Select Case Abs(Player.xm) 'use abs so we can handle movement to the left
                    Case 0
                        Player.state = Standing
                    Case 1 To MaxWalkingMomentum
                        Player.state = Walking
                    Case (MaxWalkingMomentum + 1) To MaxRunningMomentum
                        Player.state = Running
                    End Select
                Else
                    Player.state = Ducking
                End If
            End If
        Else
            If Player.ym >= 0 Then 'no need to check when moving upwards
                For i = LeftMostOnscreenObj To RightMostOnscreenObj
                    Select Case LObject(i).type
                    Case obj_Invisible1UP, obj_InvisibleCoin, obj_Coin, obj_CoinSP, obj_InvisMushroom, obj_InvisStar
                        'don't check if not solid object
                    Case Else
                        If ((Player.X + MarioWidth - 8 > LObject(i).X) And (Player.X + MarioWidth - 8 <= LObject(i).X + LObject(i).width)) Or ((Player.X >= LObject(i).X) And (Player.X < LObject(i).X + LObject(i).width - 8)) Then
                            'player on same x-plane as object
                            If (Player.Y + Player.height > LObject(i).Y) And ((Player.Y + Player.height) - LObject(i).Y) < GravitySpeed + 3 Then
                                'player on same y plane
                                'set player at correct level above object
                                Player.Y = LObject(i).Y - Player.height + 3
                                'make sure gravity will not make player fall
                                Player.willfall = False
                                GravityFrame = 0
                                If Player.ym > 0 Then Player.ym = 0
                                If Player.Ducking = False Then
                                    'change state from falling or jumping to walking, running, etc.
                                    Select Case Abs(Player.xm) 'use abs so we can handle movement to the left
                                    Case 0
                                        Player.state = Standing
                                    Case 1 To MaxWalkingMomentum
                                        Player.state = Walking
                                    Case (MaxWalkingMomentum + 1) To MaxRunningMomentum
                                        Player.state = Running
                                    End Select
                                Else
                                    Player.state = Ducking
                                End If
                            End If
                        End If
                    End Select
                Next
            End If
        End If
    End If
    
    'if willfall remained true, then player's y did not need to be set (to stand on the object), so, reset it the way it was
    If Player.willfall Then Player.Y = Player.Y - GravitySpeed
    
    
    'apply gravity to player was here
    'move mario was here
    

    'see if each enemy is standing on object such as ground or block
    'if willfall remains true, the enemy will fall due to gravity
    Dim i2 As Long
    For i = 0 To UBound(Enemies)
        If Enemies(i).state < state_inactive Then
            'apply gravity to enemy
            If Enemies(i).willfall Then Enemies(i).Y = Enemies(i).Y + GravitySpeed
            Enemies(i).willfall = True
        
            If Enemies(i).Y + Enemies(i).height > ScreenGameHeight - 72 Then
                'below ground level, so unless in a pit, water, or lava, then we're standing
                'set enemy at correct level above object
                Enemies(i).Y = ScreenGameHeight - 72 - Enemies(i).height + 3
                Enemies(i).willfall = False
            Else
                'i is current enemy, i2 is all objects
                For i2 = LeftMostOnscreenObj To RightMostOnscreenObj
                'TODO, check farleft to farright objs
                    Select Case LObject(i2).type
                    Case obj_Invisible1UP, obj_InvisibleCoin, obj_Coin, obj_CoinSP, obj_InvisMushroom, obj_InvisStar
                    'don't check if not solid object
                    Case Else
                        If ((Enemies(i).X + Enemies(i).width > LObject(i2).X) And (Enemies(i).X + Enemies(i).width <= LObject(i2).X + Enemies(i).width)) Or ((Enemies(i).X >= LObject(i2).X) And (Enemies(i).X < LObject(i2).X + Enemies(i).width)) Then
                            'enemy on same x-plane as object
                            If (Enemies(i).Y + Enemies(i).height > LObject(i2).Y) And ((Enemies(i).Y + Enemies(i).height - LObject(i2).Y) < GravitySpeed + 3) Then
                                'set enemy at correct level above object
                                Enemies(i).Y = LObject(i2).Y - Enemies(i).height + 3
                                Enemies(i).willfall = False
                            End If
                        End If
                    End Select
                Next
            End If
        End If
    Next
    


    
    'collision detection (player vs objects)
    For i = LeftMostOnscreenObj To RightMostOnscreenObj
        SetRect PlayerRect, Player.X + 6, Player.Y + 6, MarioWidth - 12, Player.height - 12
        SetRect ObjectRect, LObject(i).X, LObject(i).Y, LObject(i).width, LObject(i).height
        CollisionResult = CheckCollision(PlayerRect, ObjectRect, LObject(i).type)
        If CollisionResult <> 0 Then
            Select Case CollisionResult
                Case col_Generic
                    If LObject(i).type = obj_Coin Then
                        LObject(i).Y = 1000 'todo, remove coin
                        AddCoins 1
                    End If
                    
                Case col_FromBottom
                    Player.Y = LObject(i).Y + LObject(i).height
                    Player.ym = 0
                    Player.willfall = True
                    PerformJump = False
                    Player.ym = 0
                    JumpSteps = -1
                    JumpStepsUsed = 0
                    Select Case LObject(i).type
                        Case obj_QuestionBlock
                            'if it's a ? block, activate it
                            If LObject(i).state = objState_Normal Then
                                LObject(i).state = objState_Used
                                AddCoins 1
                            End If
                        Case obj_Brick
                            If Player.BodyType = Big Then
                                'todo, bust brick
                                LObject(i).Y = 5000
                                'todo, if enemy on block, kill him
                                'todo, if coin on block, get it
                            End If
                    End Select
                    'todo,
                    'if obj is invisible something, show it and activate it
                    
                    'todo, collision detection is wrong. a big mario jumping into a 2-space gap should not activate the ? block
                    'todo, also, a ? block (that is unused), or a brick, is moved upwards when hit
                    
                Case col_FromLeft
                    Player.X = LObject(i).X - MarioWidth
                    If Player.xm > 0 Then Player.xm = 0

                Case col_FromRight
                    Player.X = LObject(i).X + LObject(i).width
                    If Player.xm < 0 Then Player.xm = 0
                
            End Select
        End If
    Next



    'collision detection (player vs enemies)
    'todo: also need collision detection for mushrooms, flowers, stars, etc.
    For i = 0 To UBound(Enemies)
        If Enemies(i).state < state_dyingJumpedOn Then
            SetRect PlayerRect, Player.X + 6, Player.Y + 6, TileSize - 12, Player.height - 12
            SetRect ObjectRect, Enemies(i).X, Enemies(i).Y, Enemies(i).width, Enemies(i).height
            CollisionResult = CheckCollisionWithEnemy(PlayerRect, ObjectRect, Enemies(i).type)
            If CollisionResult <> 0 Then
            
                Select Case Enemies(i).type
                
                    Case enemy_goomba
                        Select Case CollisionResult
                            Case col_FromTop
                                Enemies(i).state = state_dyingJumpedOn
                                Enemies(i).special = 60
                                Enemies(i).xm = 0
                                Enemies(i).ym = 0
                                DSound.PlaySound SoundID(SndStomp)
                            Case Else 'col_Generic
                                PlayerTakeDamage
                        End Select
                        
                    Case enemy_turtle_green, enemy_turtle_red
                        If Enemies(i).special2 = 0 Then 'no collision right after we jump on him to avoid him getting hung up on us
                            Select Case CollisionResult
                                Case col_FromTop
                                    'if already in shell, stop him
                                    If Enemies(i).state = state_inshell Then
                                        'todo: can he get out now?
                                        Enemies(i).xm = 0
                                        DSound.PlaySound SoundID(SndStomp) 'todo, add proper sound
                                    Else
                                        'put him in his shell
                                        Enemies(i).state = state_inshell
                                        Enemies(i).special = 60 'todo, set correct amount of time til pop out of shell
                                        Enemies(i).special2 = 20 'set brief amount of time in which there will be no collision, so he doesn't get hung up on us
                                        Enemies(i).xm = 0
                                        DSound.PlaySound SoundID(SndStomp) 'todo, add proper sound
                                        'TODO
                                        Player.ym = -6
                                    End If
                                Case Else 'col_Generic
                                    If Enemies(i).state = state_normal Then
                                        PlayerTakeDamage
                                    Else 'todo, not sure if this will suffice
                                        'if in shell, kick him
                                        Enemies(i).special2 = 20
                                        DSound.PlaySound SoundID(SndKick)
                                        Enemies(i).special = -1 'he can't get out of his shell once he's been kicked
                                        If Player.X <= (Enemies(i).X + Enemies(i).width / 2) Then
                                            Enemies(i).xm = 4 'todo: set proper speed
                                        Else
                                            Enemies(i).xm = -4 'todo: set proper speed
                                        End If
                                    End If
                            End Select
                        End If
                
                End Select 'enemy type
            
            End If 'if collision
        End If 'if inactive
    Next

    
    
    

    'move mario -- apply current momentum to change x and y
    With Player
        .X = .X + .xm
        .Y = .Y + .ym
        If .xm < 0 Then
            .FacingLeft = 1
        ElseIf .xm > 0 Then
            .FacingLeft = 0
        End If
    End With
    
    PlayerLastY = PlayerLastYTemp
    PlayerLastYTemp = Player.Y
    
    'can't run off left side of screen
    If Player.X < OnscreenStart Then Player.X = OnscreenStart
    
    
    'scroll the screen, if needed   'todo - gradually add scrolling so that it's seemless. also, you don't have to be past screen center to scroll    If Player.X > OnscreenStart + 408 Then
    If Player.X > OnscreenStart + 408 Then
        If Player.xm > 0 Then
        
            OnscreenStart = OnscreenStart + Player.xm
            
            Dim OnscreenColumnL As Long
            OnscreenColumnL = OnscreenStart / TileSize
    
    
            'find left-most onscreen object
            Dim tmpLeftMostOnscreen As Long
            If LeftMostOnscreenObj = -1 Then
                'if no objs onscreen
                tmpLeftMostOnscreen = 0
            Else
                tmpLeftMostOnscreen = LeftMostOnscreenObj
            End If
            For i = tmpLeftMostOnscreen To UBound(LObject)
                If (LObject(i).X + LObject(i).width > OnscreenStart) And (LObject(i).X < OnscreenStart + ScreenGameWidth) Then
                    LeftMostOnscreenObj = i
                    Exit For
                End If
            Next
            
            
            'find farleft obj
            If LeftMostOnscreenObj > 0 Then
                For i = (LeftMostOnscreenObj - 1) To 0 Step -1
                    If OnscreenColumnL - LObject(i).Column <= 5 Then
                        FarLeftObj = i
                    Else
                        'too far away, so quit
                        Exit For
                    End If
                Next
            Else
                'start of stage, so set rightmostonscreenobj
                For i = LeftMostOnscreenObj To UBound(LObject)
                    If LObject(i).X < OnscreenStart + ScreenGameWidth Then
                        RightMostOnscreenObj = i
                        FarRightObj = i
                    Else
                        Exit For
                    End If
                Next
            End If
            
            
            Dim OnscreenColumnR As Long
            OnscreenColumnR = (OnscreenStart + ScreenGameWidth) / TileSize
            
            
            'find right-most onscreen object
            If LeftMostOnscreenObj = -1 Then
                'if no objs onscreen
                tmpLeftMostOnscreen = 0
            Else
                tmpLeftMostOnscreen = LeftMostOnscreenObj
            End If
            For i = tmpLeftMostOnscreen To UBound(LObject)
                If LObject(i).X < OnscreenStart + ScreenGameWidth Then
                    RightMostOnscreenObj = i
                Else
                    'no longer dealing with onscreen objects, so quit
                    Exit For
                End If
            Next
            
            
            'find farright obj
            For i = RightMostOnscreenObj To UBound(LObject)
                If LObject(i).Column - OnscreenColumnR <= 5 Then
                    FarRightObj = i
                Else
                    'too far away, so quit
                    Exit For
                End If
            Next
            
        End If
    End If
    
    
    
    
    
    
    'collision detection (enemies vs objects)
    For i = 0 To UBound(Enemies)
        For i2 = LeftMostOnscreenObj To RightMostOnscreenObj
            SetRect EnemyRect, Enemies(i).X - 3, Enemies(i).Y - 3, Enemies(i).width - 3, Enemies(i).height - 3
            SetRect ObjectRect, LObject(i2).X, LObject(i2).Y, LObject(i2).width, LObject(i2).height
            CollisionResult = CheckCollision(EnemyRect, ObjectRect, LObject(i2).type)
            If CollisionResult <> 0 Then
                Select Case CollisionResult
                    Case col_Generic
                        
                    Case col_FromBottom
                        
                    Case col_FromLeft
                        Enemies(i).xm = -2
    
                    Case col_FromRight
                        Enemies(i).xm = 2
                    
                End Select
            End If
    
'            If (((Enemies(i).X + Enemies(i).width) >= (LObject(i2).X)) And ((Enemies(i).X + Enemies(i).width) <= (LObject(i2).X + Enemies(i).width))) Or (((Enemies(i).X) >= (LObject(i2).X)) And ((Enemies(i).X) <= (LObject(i2).X + Enemies(i).width))) Then
'                'enemy on same x-plane as object
'                If (((Enemies(i).Y + Enemies(i).height) >= (LObject(i2).Y)) And ((Enemies(i).Y + Enemies(i).height) <= (LObject(i2).Y + Enemies(i).height + (Enemies(i).height / 2)))) Or (((Enemies(i).Y) >= (LObject(i2).Y - (Enemies(i).height / 2))) And ((Enemies(i).Y) <= (LObject(i2).Y + Enemies(i).height))) Then
'                    'enemy on same y-plane as object  -->  Collision
'                    'GENERIC COLLISION
'                    'Enemies(i).X = -Enemies(i).xm
'                End If
'            End If
        Next
    Next
    
    
    'collision detection (enemies vs other enemies)
    For i = 0 To UBound(Enemies)
        For i2 = 0 To UBound(Enemies)
            If i <> i2 Then
              'don't check against selEnemies(i2)f
                SetRect EnemyRect, Enemies(i).X - 3, Enemies(i).Y - 3, Enemies(i).width - 3, Enemies(i).height - 3
                SetRect ObjectRect, Enemies(i2).X, Enemies(i2).Y, Enemies(i2).width, Enemies(i2).height
                CollisionResult = CheckCollisionWithEnemy(EnemyRect, ObjectRect, Enemies(i2).type)
                If CollisionResult <> 0 Then
                    Select Case CollisionResult
                        Case col_Generic

                        Case col_FromBottom
                            
                        Case col_FromLeft, col_FromRight
                            'TODO
                            If (Enemies(i).type = enemy_turtle_green) And (Enemies(i).state = state_inshell) And (Enemies(i).xm <> 0) Then
                                Enemies(i2).state = state_dead
                                Enemies(i2).X = -9999
                                Debug.Print "1111"
                            ElseIf (Enemies(i2).type = enemy_turtle_green) And (Enemies(i2).state = state_inshell) And (Enemies(i2).xm <> 0) Then
                                Enemies(i).state = state_dead
                                Enemies(i).X = -9999
                                Debug.Print "1111"
                            Else
                                Enemies(i).xm = InvertXM(Enemies(i).xm)
                                Enemies(i2).xm = InvertXM(Enemies(i2).xm)
                            End If
                    
                    End Select
                End If
            End If
        Next
    Next
    
    'to here took an average of 0.45 ms
    
    
    DrawEverything
    
    
    If LockFramerate Then
    'wait until frame has taken 1/60 of a second
        Do Until 1 = 2
            QueryPerformanceCounter perfEnd
            'Calculate elapsed time (in milliseconds, eg 1000 = 1 second)
            'for 60 fps, we want 16.66666 ms.
            'average right now is about 12
            Elapsed = 1000 * (perfEnd - perfStart) / perfFreq
            'Debug.Print Elapsed
            'Debug.Print CLng(16.666 - Elapsed)
            'If Elapsed < 15.4 Then Sleep CLng(16.666 - Elapsed)
            If Elapsed >= 16.66 Then Exit Do
            DoEvents
        Loop
    End If

  Loop
    Exit Sub
    
ErrHandler:
    If Err.Number = -2005532222 Then
        If Form1.WindowState = vbMinimized Then
            Do Until Form1.WindowState <> vbMinimized
                'if game is alt+tabbed out, pause until restored
                DoEvents
            Loop
        End If
        'DestroyPrimaryAndBackBuffer
        'UnloadAllPics
        Debug.Print "restoring surfaces"
        DX_Draw.RestoreAllSurfaces 'i have no idea how this works or what's going on...
        DoEvents
        'CreatePrimaryAndBackBuffer
        'LoadAllPics
        DoEvents
    Else
        Debug.Print "MainGameLoop:  " & Err.Number & " - " & Err.Description
    End If

End Sub



Sub DrawEverything()
    On Error GoTo ErrHandler
    Dim i As Long
    
    
    'tmp, draw top reserved area (debug)
    With DestRect
        .Left = ScreenOffsetX
        .Top = ScreenOffsetY
        .Right = ScreenOffsetX + ScreenGameWidth
        .Bottom = ScreenOffsetY + 72
    End With
    BackBuffer.BltColorFill DestRect, 23068



    'tmp - set font color
    BackBuffer.SetFont Form1.Font
    BackBuffer.SetForeColor vbYellow


    'draw floor
    Dim FloorFilled As Long
    Dim FloorOffset As Long
    FloorOffset = OnscreenStart Mod TileSize
    FloorFilled = ScreenOffsetX - FloorOffset
    
    SetRect SrcRect, 0, 0, FloorBitmapWidth, 72
    Do Until FloorFilled >= (ScreenResX - ScreenOffsetX)
        BackBuffer.BltFast FloorFilled, ScreenResY - ScreenOffsetY - 72, sprFloor, SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
        FloorFilled = FloorFilled + FloorBitmapWidth
    Loop
    
    Select Case Frames
        Case 0 To 20
            MasterAniFrame3Step = 0
        Case 21 To 40
            MasterAniFrame3Step = 1
        Case 41 To 60
            MasterAniFrame3Step = 2
    End Select
    Select Case Frames
        Case 0 To 30
            MasterAniFrame2Step = 0
        Case 31 To 60
            MasterAniFrame2Step = 1
    End Select
    
    'draw objects
    For i = LeftMostOnscreenObj To RightMostOnscreenObj
        SetRect SrcRect, 0, 0, LObject(i).width, LObject(i).height
        Select Case LObject(i).type
            Case obj_BlockH1
                BackBuffer.BltFast LObject(i).X - OnscreenStart + ScreenOffsetX, LObject(i).Y + ScreenOffsetY, sprBlock, SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
            
            Case obj_QuestionBlock
                If LObject(i).state = objState_Normal Then
                    BackBuffer.BltFast LObject(i).X - OnscreenStart + ScreenOffsetX, LObject(i).Y + ScreenOffsetY, sprQuestionBlock(MasterAniFrame3Step), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                Else
                    BackBuffer.BltFast LObject(i).X - OnscreenStart + ScreenOffsetX, LObject(i).Y + ScreenOffsetY, sprQuestionBlock(3), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                End If
            
            Case obj_Coin
                BackBuffer.BltFast LObject(i).X - OnscreenStart + ScreenOffsetX, LObject(i).Y + ScreenOffsetY, sprCoin(MasterAniFrame3Step), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
            
            Case obj_Brick
                BackBuffer.BltFast LObject(i).X - OnscreenStart + ScreenOffsetX, LObject(i).Y + ScreenOffsetY, sprBrick, SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
            
            Case obj_PipeV2 To obj_PipeV14
                BackBuffer.BltFast LObject(i).X - OnscreenStart + ScreenOffsetX, LObject(i).Y + ScreenOffsetY, sprPipeV(obj_PipeV14 - LObject(i).type - 2), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                'BackBuffer.BltFast LObject(i).X - OnscreenStart + ScreenOffsetX, LObject(i).Y + ScreenOffsetY, sprPipeV(0), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
            
            Case obj_Pit
                With DestRect
                    .Left = LObject(i).X - OnscreenStart + ScreenOffsetX
                    .Top = LObject(i).Y + ScreenOffsetY
                    .Right = LObject(i).X - OnscreenStart + ScreenOffsetX + TileSize 'LObject(i).width
                    .Bottom = LObject(i).Y + ScreenOffsetY + 72
                End With
                BackBuffer.BltColorFill DestRect, LevelBGColor
        End Select
        'temp - draw object number and X
        BackBuffer.DrawText LObject(i).X - OnscreenStart + ScreenOffsetX + 10, LObject(i).Y + ScreenOffsetY + 10, i, False
        BackBuffer.DrawText LObject(i).X - OnscreenStart + ScreenOffsetX + 10, LObject(i).Y + ScreenOffsetY + 30, LObject(i).X, False
    Next
    
    
    'draw enemies, todo - only onscreen ones
    For i = 0 To UBound(Enemies)
        'todo, here we could get a speed increase by first checking if we'll have to draw it (eg, is it active?)
        SetRect SrcRect, 0, 0, Enemies(i).width, Enemies(i).height
        Select Case Enemies(i).type
        
            Case enemy_goomba
                Select Case Enemies(i).state
                    Case state_normal
                        BackBuffer.BltFast Enemies(i).X - OnscreenStart + ScreenOffsetX, Enemies(i).Y + ScreenOffsetY, sprGoomba(MasterAniFrame2Step), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                    Case state_dyingJumpedOn
                        SetRect SrcRect, 0, 0, Enemies(i).width, 24
                        BackBuffer.BltFast Enemies(i).X - OnscreenStart + ScreenOffsetX, Enemies(i).Y + ScreenOffsetY + 24, sprGoomba(2), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                        If Enemies(i).special < 20 Then
                            'done showing death animation, mark for removal
                            Enemies(i).state = state_dead
                            Enemies(i).X = -9999
                        End If
                End Select
                
            Case enemy_turtle_green
                Select Case Enemies(i).state
                    Case state_normal
                        BackBuffer.BltFast Enemies(i).X - OnscreenStart + ScreenOffsetX, Enemies(i).Y + ScreenOffsetY, sprTurtleGreen(MasterAniFrame2Step), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                    Case state_inshell
                        BackBuffer.BltFast Enemies(i).X - OnscreenStart + ScreenOffsetX, Enemies(i).Y + ScreenOffsetY, sprTurtleGreen(2), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                    
'todo: implement turtle popping up after set time, drawing the movements when needed
'                    Case 20 To 60 'turtle is in shell, sitting still. counting down until pop out of shell
                        '\/ simply copied from goomba -- change
'                        SetRect SrcRect, 0, 0, Enemies(i).width, 24
'                        BackBuffer.BltFast Enemies(i).X - OnscreenStart + ScreenOffsetX, Enemies(i).Y + ScreenOffsetY + 24, sprTurtleGreen(2), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
'                        Enemies(i).state = Enemies(i).state - 1
'                        If Enemies(i).state < 20 Then
'                            'done showing death animation, mark for removal
'                            Enemies(i).state = state_dead
'                            Enemies(i).X = -9999
'                        End If
                End Select
        End Select
        'temp - draw object number and Y
        BackBuffer.DrawText Enemies(i).X - OnscreenStart + ScreenOffsetX + 20, Enemies(i).Y + ScreenOffsetY + 30, i, False
        'BackBuffer.DrawText Enemies(i).X - OnscreenStart + ScreenOffsetX + 10, Enemies(i).Y + ScreenOffsetY + 30, Enemies(i).Y, False
    Next


    'draw mario
    SetRect SrcRect, 0, 0, TileSize, CInt(Player.height)
    Dim AnimationType As Long
    If Player.state = Falling Then
        'use same sprite as was being used when fall started
        AnimationType = FallingType 'fallingtype is the player state from when the fall started (eg did mario jump or was he walking off a ledge?)
    Else
        AnimationType = Player.state
    End If
    If (Player.takingdamage = 0) Or ((Abs(Player.takingdamage) / 10) Mod 2 <> 0) Then
    'if property's tens place is a multiple of two, don't draw. this makes the player flash
        'draw
        Select Case AnimationType 'AnimationType is same as State unless we're falling (see code above)
            Case Walking
                Select Case Player.AniFrame
                    Case 0 To 6
                        'note: if player is big, we add 6 to the frame index
                        BackBuffer.BltFast Player.X - OnscreenStart + ScreenOffsetX, Player.Y + ScreenOffsetY, sprMarioRun(0 + (Player.FacingLeft * 3) + (Player.BodyType * 6)), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                    Case 7 To 13
                        BackBuffer.BltFast Player.X - OnscreenStart + ScreenOffsetX, Player.Y + ScreenOffsetY, sprMarioRun(1 + (Player.FacingLeft * 3) + (Player.BodyType * 6)), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                    Case 14 To 20
                        BackBuffer.BltFast Player.X - OnscreenStart + ScreenOffsetX, Player.Y + ScreenOffsetY, sprMarioRun(2 + (Player.FacingLeft * 3) + (Player.BodyType * 6)), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                End Select
                If Not (Player.state = Falling) Then
                    If Player.AniFrame = 20 Then Player.AniFrame = -1
                    Player.AniFrame = Player.AniFrame + 1
                End If
                
            Case Running
                Select Case Player.AniFrame
                    Case 0 To 3
                        'note: if player is big, we add 6 to the frame index
                        BackBuffer.BltFast Player.X - OnscreenStart + ScreenOffsetX, Player.Y + ScreenOffsetY, sprMarioRun(0 + (Player.FacingLeft * 3) + (Player.BodyType * 6)), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                    Case 4 To 7
                        BackBuffer.BltFast Player.X - OnscreenStart + ScreenOffsetX, Player.Y + ScreenOffsetY, sprMarioRun(1 + (Player.FacingLeft * 3) + (Player.BodyType * 6)), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                    Case 8 To 11
                        BackBuffer.BltFast Player.X - OnscreenStart + ScreenOffsetX, Player.Y + ScreenOffsetY, sprMarioRun(2 + (Player.FacingLeft * 3) + (Player.BodyType * 6)), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                    Case Else
                        'higher than 11 (from previous walk)
                        BackBuffer.BltFast Player.X - OnscreenStart + ScreenOffsetX, Player.Y + ScreenOffsetY, sprMarioRun(0 + (Player.FacingLeft * 3) + (Player.BodyType * 6)), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                        Player.AniFrame = 0
                End Select
                If Not (Player.state = Falling) Then
                    If Player.AniFrame = 11 Then Player.AniFrame = -1
                    Player.AniFrame = Player.AniFrame + 1
                End If
            Case Standing
                BackBuffer.BltFast Player.X - OnscreenStart + ScreenOffsetX, Player.Y + ScreenOffsetY, sprMarioStand(Player.FacingLeft + (Player.BodyType * 2)), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
            Case Jumping
                If Player.Ducking = False Then
                    BackBuffer.BltFast Player.X - OnscreenStart + ScreenOffsetX, Player.Y + ScreenOffsetY, sprMarioJump(Player.FacingLeft + (Player.BodyType * 2)), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                Else
                    SetRect SrcRect, 0, 0, TileSize, PlayerBig
                    BackBuffer.BltFast Player.X - OnscreenStart + ScreenOffsetX, Player.Y - TileSize + ScreenOffsetY, sprMarioDuck(Player.FacingLeft), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                End If
            Case Ducking
                SetRect SrcRect, 0, 0, TileSize, PlayerBig
                BackBuffer.BltFast Player.X - OnscreenStart + ScreenOffsetX, Player.Y - TileSize + ScreenOffsetY, sprMarioDuck(Player.FacingLeft), SrcRect, DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
        End Select
    End If
    
    
    'draw texts
    BackBuffer.SetFont Form1.Font
    BackBuffer.SetForeColor vbWhite
    BackBuffer.DrawText 700, 30 + ScreenOffsetY, "Time = " & StageTime, False
    BackBuffer.DrawText 550, 30 + ScreenOffsetY, "FPS = " & Frames, False
    BackBuffer.DrawText 450, 30 + ScreenOffsetY, "FPS = " & FPS, False
    If LockFramerate Then BackBuffer.DrawText 450, 50 + ScreenOffsetY, "Framerate Locked", False
    'BackBuffer.DrawText 450, 50 + ScreenOffsetY, "60 Frames = " & TimeFor60Frames, False
    BackBuffer.DrawText 300, 30 + ScreenOffsetY, "WillFall = " & Player.willfall, False
    BackBuffer.DrawText 170, 10 + ScreenOffsetY, "FL-L--R--FR", False
    BackBuffer.DrawText 170, 30 + ScreenOffsetY, FarLeftObj & "-" & LeftMostOnscreenObj & "-" & RightMostOnscreenObj & "-" & FarRightObj, False
    BackBuffer.DrawText 300, 80 + ScreenOffsetY, GetStateName(Player.state), False
    'BackBuffer.DrawText 200, 80 + ScreenOffsetY, MouseX & "," & MouseY, False
    BackBuffer.DrawText 200, 80 + ScreenOffsetY, Player.X & "," & Player.Y, False
    BackBuffer.DrawText 650, 80 + ScreenOffsetY, "Coins = " & NumCoins, False
 
    BackBuffer.DrawText 450, 80 + ScreenOffsetY, "Elapsed = " & CStr(Elapsed), False

    
    'fill border around game screen
    With DestRect 'left
        .Left = 0
        .Top = 0
        .Right = ScreenOffsetX
        .Bottom = ScreenResY
    End With
    BackBuffer.BltColorFill DestRect, 11
    With DestRect 'top
        .Left = ScreenOffsetX
        .Top = 0
        .Right = ScreenResX - ScreenOffsetX
        .Bottom = ScreenOffsetY
    End With
    BackBuffer.BltColorFill DestRect, 11
    With DestRect 'right
        .Left = ScreenResX - ScreenOffsetX
        .Top = 0
        .Right = ScreenResX
        .Bottom = ScreenResY
    End With
    BackBuffer.BltColorFill DestRect, 11
    With DestRect 'bottom
        .Left = ScreenOffsetX
        .Top = ScreenResY - ScreenOffsetY
        .Right = ScreenResX - ScreenOffsetX
        .Bottom = ScreenResY
    End With
    BackBuffer.BltColorFill DestRect, 11
    
    
    'flip into view
    View.Flip Nothing, DDFLIP_WAIT
    
    Exit Sub
    
ErrHandler:
    If Err.Number = -2005532222 Then
        If Form1.WindowState = vbMinimized Then
            Do Until Form1.WindowState <> vbMinimized
                'if game is alt+tabbed out, pause until restored
                DoEvents
            Loop
        End If
        'DestroyPrimaryAndBackBuffer
        'UnloadAllPics
        Debug.Print "restoring surfaces"
        'BackBuffer.Restore
        'LoadAllPics
        DX_Draw.RestoreAllSurfaces 'i have no idea how this works or what's going on...
        DoEvents
        'CreatePrimaryAndBackBuffer
        'LoadAllPics
        'DoEvents
    Else
        Debug.Print "MainGameLoop:  " & Err.Number & " - " & Err.Description
    End If
End Sub



Private Function GetObjectDimension(width_or_height As Long, objType As Long) As Long
    Select Case objType
        Case obj_BlockH1, obj_Coin, obj_Brick, obj_BlockV1, obj_CoinSP, obj_FirechainBlock, obj_Invisible1UP, obj_InvisibleCoin, obj_InvisMushroom, obj_InvisStar, obj_MultiCoinBrick, obj_MushroomBrick, obj_MushroomQuestion, obj_OneUPBrick, obj_QuestionBlock, obj_StarBrick, obj_VineBrick, obj_Null
            GetObjectDimension = TileSize
                    
        Case obj_PipeV2 To obj_PipeV14
            If width_or_height = 0 Then           'width
                GetObjectDimension = TileSize * 2
            Else                                  'height
                GetObjectDimension = TileSize * 2 + (TileSize * (objType - obj_PipeV2))
            End If
            
        Case Else
            If width_or_height = 0 Then           'width
                GetObjectDimension = TileSize
            Else                                  'height
                GetObjectDimension = TileSize
            End If
    End Select
End Function



Private Function CheckCollision(Rect1 As RECT, Rect2 As RECT, Obj2Type As Long) As Long
    Dim ResultRECT As RECT
    Dim irResult As Long
    irResult = IntersectRect(ResultRECT, Rect1, Rect2)
    If irResult = 0 Then
        CheckCollision = col_None
    Else
        Select Case Obj2Type

            Case obj_Coin
                CheckCollision = col_Generic
                'todo, needs to be NONE for enemies hitting these
                ' ^ huh?... don't remember why i wrote that
                '4/26: is there any object that will even affect enemies with a generic collision?
                
            Case obj_Null
                CheckCollision = col_None
                
            Case Else
                'determine type of collision
                
                '   player's top is between object's bottom and 12 pixels above the object's bottom
                If (Rect1.Top >= Rect2.Bottom - 12) And (Rect1.Top <= Rect2.Bottom) Then
                    CheckCollision = col_FromBottom
                    Exit Function
                End If
                
                
                If (Rect1.Right <= Rect2.Left + MaxRunningMomentum) And (Rect1.Right >= Rect2.Left) Then
                    CheckCollision = col_FromLeft
                    Exit Function
                
                ElseIf (Rect1.Left >= Rect2.Right - MaxRunningMomentum) And (Rect1.Left <= Rect2.Right) Then
                    CheckCollision = col_FromRight
                    Exit Function
                End If
                
                '
                CheckCollision = col_Generic
                
        End Select
    End If
End Function


Private Function CheckCollisionWithEnemy(Rect1 As RECT, Rect2 As RECT, EnemyType As Long) As Long
    Dim ResultRECT As RECT
    Dim irResult As Long
    irResult = IntersectRect(ResultRECT, Rect1, Rect2)
    If (irResult = 0) Or (Player.takingdamage > 0) Then 'TODO - when we check enemy vs enemy, we can't be dealing with the player's condition...
        'no collision if no intersection or if player is taking damage
        CheckCollisionWithEnemy = col_None
        Exit Function
    End If
    
    'todo: if player's ym is neg. then it can't be fromtop
    
    
'    Select Case EnemyType
'        Case enemy_goomba
'            CheckCollision = col_Generic
'
'        Case Else
'        determine type of collision
'
'            If (Rect1.Top >= Rect2.Bottom - 12) And (Rect1.Top <= Rect2.Bottom) Then
'                CheckCollision = col_FromBottom
'                Exit Function
'            End If

            If (Rect1.Bottom <= Rect2.Top + 12) And (Rect1.Bottom > Rect2.Top) Then
                CheckCollisionWithEnemy = col_FromTop
                Exit Function
            End If
            
            
            If (Rect1.Right <= Rect2.Left + MaxRunningMomentum) And (Rect1.Right >= Rect2.Left) Then
                CheckCollisionWithEnemy = col_FromLeft
                Exit Function
            
            ElseIf (Rect1.Left >= Rect2.Right - MaxRunningMomentum) And (Rect1.Left <= Rect2.Right) Then
                CheckCollisionWithEnemy = col_FromRight
                Exit Function
            End If
            
            '
            CheckCollisionWithEnemy = col_Generic
            
'    End Select
End Function



Public Function InvertXM(currentXM As Long) As Long
    '     xm = -4  - -4  -  -4
    '     xm = 4   -  4  -  4
    InvertXM = currentXM - currentXM - currentXM
End Function




Sub GameOver(Reason As Byte)
    'unload graphics
    DestroyPrimaryAndBackBuffer
    UnloadAllPics
    
    DSound.Terminate
    
    'reset screen res
    'SetDisplayMode
    'unload DX
    Form1.ShutItDown
    End
End Sub




Function GetStateName(lngValue As Byte) As String
    'Public Const Standing As Byte = 0
    'Public Const Walking As Byte = 1
    'Public Const Running As Byte = 2
    'Public Const Jumping As Byte = 3
    'Public Const Sliding As Byte = 4
    'Public Const Ducking As Byte = 5
    'Public Const Falling As Byte = 6
    Select Case lngValue
        Case 0
            GetStateName = "standing"
        Case 1
            GetStateName = "walking"
        Case 2
            GetStateName = "running"
        Case 3
            GetStateName = "jumping"
        Case 4
            GetStateName = "sliding"
        Case 5
            GetStateName = "ducking"
        Case 6
            GetStateName = "falling"
        Case Else
            GetStateName = "UNKNOWN"
    End Select
End Function



Public Sub ReloadLevel()
    SetUpLevel 1.1
'    Dim i As Long
'    For i = 0 To UBound(Enemies)
'        With Enemies(i)
'          .xm = -2
'          .ym = 0
'          '.state = state_normal
'        End With
'    Next
    MainGameLoop
End Sub




Private Sub PlayerTakeDamage(Optional InstantDeath As Boolean)

    If (Player.BodyType = Small) Or (InstantDeath = True) Then
        'die
        DSound.PlaySound SoundID(MusicMarioDie)
        NumLives = NumLives - 1
        Player.state = Dying
        'todo, instead go to a function that checks for game over
        ReloadLevel
        Exit Sub
'    Else
'        If Player.state = Ducking Then Player.state = Standing
    End If
    
    
    
    Player.takingdamage = 60
    Player.height = PlayerSml
    Player.BodyType = Small
    'todo, move player's y down 48 (add to it) when going from big to small
    

End Sub



Private Sub AddCoins(num2add As Long)
    Dim tempnum As Long
    tempnum = NumCoins + num2add
    If tempnum >= 100 Then
        NumCoins = tempnum - 100
        NumLives = NumLives + 1
    Else
        NumCoins = tempnum
    End If
End Sub



Private Function CheckForPit() As Boolean
    Dim Count As Long
    Dim i As Long
    For i = LeftMostOnscreenObj To RightMostOnscreenObj
        Select Case LObject(i).type
        
        Case obj_Pit, obj_PitWater, obj_PitLava
            If Player.X = LObject(i).X Then
                'player is exactly above pit
                Count = 2
                Exit For
            End If
            If Count = 0 Then
                If ((Player.X + MarioWidth - 8 > LObject(i).X) And (Player.X + MarioWidth - 8 <= LObject(i).X + LObject(i).width)) Or ((Player.X >= LObject(i).X) And (Player.X < LObject(i).X + LObject(i).width - 8)) Then
                    'player on same x-plane as object
                    Count = Count + 1
                End If
            Else
                If ((Player.X + MarioWidth > LObject(i).X) And (Player.X + MarioWidth <= LObject(i).X + LObject(i).width)) Or ((Player.X >= LObject(i).X) And (Player.X < LObject(i).X + LObject(i).width)) Then
                    'player on same x-plane as object
                    Count = Count + 1
                End If
            End If
        End Select
    Next
    
    If Count > 1 Then
        CheckForPit = True
    End If
        
    
End Function


